<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
      >通过
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)">驳回
      </el-button>

      <el-dropdown @command="(command) => handleCommand(command)" style="margin-left: 30px;">
        <span class="el-dropdown-link">更多<i class="el-icon-arrow-down el-icon--right"></i></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>


      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
  </el-col>
</template>

<script>
import {
  approveTaskWithVariablesAPI, updateAccountReceiptAPI,
  updateAccountStatementAPI, updateReceiveAndPayInfoAPI, accountStatementProcessCancel
} from '@/api/bpm/components/saleManage/saleorder';
import {approveTaskWithVariables} from '@/api/bpm/task';
// import { listAllUserBind } from '@/api/system/organization';

// 流程实例的详情页，可用于审批
export default {
  name: '',
  components: {
    //   Parser
  },
  props: {
    businessId: {
      default: ''
    },
    taskId: {
      default: ''
    },
    id: {
      default: ''
    },
    taskDefinitionKey: {
      default: ''
    }
  },
  data() {
    return {
      form: {
        technicianId: '',
        reason: ''
      },
      tabOptions: [
        {key: 'starter', permissionType: 'update', name: '发起人申请'},
        {key: 'deptLeader', permissionType: 'view', name: '销售主管审批'},
        {key: 'financeLeader', permissionType: 'view', name: '财务主管审核'},
        {key: 'leader', permissionType: 'view', name: '分管副总审批'},
        {key: 'uploadReceipt', permissionType: 'view', name: '上传回执'},
      ],
      permissionType: '',
    };
  },
  created() {

  },
  mounted() {
    this.permissionType = this.tabOptions.find(item => item.key == this.taskDefinitionKey).permissionType
  },
  methods: {
    //保存表格数据
    async handleAudit(pass) {
      let data = await this.getTableValue()
      this.$refs.formRef.validate(async validate => {
        if ((!validate || !data) && !!pass) return this.$message.warning('有必填项未填，请检查')
        switch (this.taskDefinitionKey) {
          case 'starter':
            await updateAccountStatementAPI(data);
            break;
          case 'uploadReceipt':
            await updateAccountReceiptAPI(data);
            break;
          case 'financeLeader':
            await updateReceiveAndPayInfoAPI(data)
            break;
        }
        let variables = {
          pass: !!pass,
        }
        approveTaskWithVariablesAPI({
          id: this.taskId,
          reason: this.form.reason,
          variables
        }).then((res) => {
          if (res.code != '-1') {
            this.$emit('handleAudit', {
              status: pass,
              title: !pass ? '驳回' : ''
            });
          }
        });
      })

    },
    getTableValue() {
      return new Promise((resolve, reject) => {
        this.$emit('getTableValue', async (data) => {
          resolve(await data);
        });
      });
    },

    //更多
    handleCommand(command) {
      if (command === 'cancel') {
        this.$confirm("是否确认作废？", {
          type: 'warning',
          cancelButtonText: '取消',
          confirmButtonText: '确定'
        }).then(() => {
          accountStatementProcessCancel({
            id: this.taskId,
            reason: this.form.reason,
            businessId: this.businessId,
          }).then(() => {
            this.$emit('handleClose');
          }).catch(() => {
            this.$message.error("流程作废失败");
          });
        }).catch(() => {});
      }
    },

  }
};
</script>

<style lang="scss"></style>
